package me.km.entities;

import com.mojang.blaze3d.platform.GlStateManager;
import net.minecraft.client.renderer.entity.model.PlayerModel;

public class ModelHuman extends PlayerModel<EntityHuman>
{
    public ModelHuman(float modelSize, boolean smallArmsIn) 
    {
        super(modelSize, smallArmsIn);
    }
    
    @Override
    public void render(EntityHuman ent, float limbSwing, float limbSwingAmount, float ageInTicks, float netHeadYaw, float headPitch, float scale)
    {
        this.setRotationAngles(ent, limbSwing, limbSwingAmount, ageInTicks, netHeadYaw, headPitch, scale);
        GlStateManager.pushMatrix();

        float factor = ent.getScale();
        GlStateManager.translatef(0.0F, -1.5f * factor + 1.5f, 0.0F);
        GlStateManager.scalef(factor, factor, factor);

        this.bipedHead.render(scale);
        this.bipedBody.render(scale);
        this.bipedRightArm.render(scale);
        this.bipedLeftArm.render(scale);
        this.bipedRightLeg.render(scale);
        this.bipedLeftLeg.render(scale);
        this.bipedHeadwear.render(scale);
        this.bipedLeftLegwear.render(scale);
        this.bipedRightLegwear.render(scale);
        this.bipedLeftArmwear.render(scale);
        this.bipedRightArmwear.render(scale);
        this.bipedBodyWear.render(scale);

        GlStateManager.popMatrix();
    }
}
