package me.km.entities;

import com.mojang.blaze3d.platform.GlStateManager;
import me.km.KajetansMod;
import net.minecraft.client.renderer.entity.EntityRendererManager;
import net.minecraft.client.renderer.entity.MobRenderer;
import net.minecraft.client.renderer.entity.model.PolarBearModel;
import net.minecraft.util.ResourceLocation;
import net.minecraftforge.api.distmarker.Dist;
import net.minecraftforge.api.distmarker.OnlyIn;

@OnlyIn(Dist.CLIENT)
public class RenderBrownBear extends MobRenderer<EntityBrownBear, PolarBearModel<EntityBrownBear>>
{
    private static final ResourceLocation BLACK_BEAR_TEXTURE = new ResourceLocation(KajetansMod.MODID, "textures/entity/bear/brownbear.png");

    public RenderBrownBear(EntityRendererManager erm)
    {
        super(erm, new PolarBearModel<>(), 0.9F);
    }

    @Override
    protected ResourceLocation getEntityTexture(EntityBrownBear entity)
    {
        return BLACK_BEAR_TEXTURE;
    }

    @Override
    protected void preRenderCallback(EntityBrownBear ent, float partialTickTime)
    {
        GlStateManager.scalef(1.2F, 1.2F, 1.2F);
        super.preRenderCallback(ent, partialTickTime);
    }
}