package me.km.networking;

import com.mojang.blaze3d.platform.GlStateManager;
import me.km.KajetansMod;
import me.km.inventory.CustomContainer;
import me.km.inventory.InventoryBase;
import net.minecraft.client.Minecraft;
import net.minecraft.client.gui.screen.inventory.ContainerScreen;
import net.minecraft.entity.player.PlayerInventory;
import net.minecraft.util.ResourceLocation;
import net.minecraft.util.text.ITextComponent;
import net.minecraftforge.api.distmarker.Dist;
import net.minecraftforge.api.distmarker.OnlyIn;

@OnlyIn(Dist.CLIENT)
public class CustomInventoryGui extends ContainerScreen
{
    /** The ResourceLocation containing the chest GUI texture. */
    private static final ResourceLocation CHEST_GUI_TEXTURE = new ResourceLocation("textures/gui/container/generic_54.png");
    private static final ResourceLocation EMPTY_TILE = new ResourceLocation(KajetansMod.MODID, "textures/gui/container/empty_tile.png");
    private final PlayerInventory pInv;
    private final InventoryBase inv;
    private final int inventoryRows;

    public CustomInventoryGui(InventoryBase inv, ITextComponent text, int id)
    {
        super(new CustomContainer(inv, Minecraft.getInstance().player, text, id), Minecraft.getInstance().player.inventory, text);
        this.pInv = Minecraft.getInstance().player.inventory;
        this.inv = inv;
        this.passEvents = false;
        this.inventoryRows = inv.getRows();
        this.ySize = 114 + this.inventoryRows * 18;
    }

    @Override
    public void render(int mouseX, int mouseY, float partialTicks)
    {
        this.renderBackground();
        super.render(mouseX, mouseY, partialTicks);
        this.renderHoveredToolTip(mouseX, mouseY);
    }

    @Override
    protected void drawGuiContainerForegroundLayer(int mouseX, int mouseY)
    {
        this.font.drawString(title.getFormattedText(), 8, 6, 4210752);
        this.font.drawString(this.pInv.getDisplayName().getFormattedText(), 8, this.ySize - 96 + 2, 4210752);
    }

    @Override
    protected void drawGuiContainerBackgroundLayer(float partialTicks, int mouseX, int mouseY)
    {
        GlStateManager.color4f(1.0F, 1.0F, 1.0F, 1.0F);
        minecraft.getTextureManager().bindTexture(CHEST_GUI_TEXTURE);
        int i = (this.width - this.xSize) / 2;
        int j = (this.height - this.ySize) / 2;
        blit(i, j, 0, 0, this.xSize, this.inventoryRows * 18 + 17);
        blit(i, j + this.inventoryRows * 18 + 17, 0, 126, this.xSize, 96);
        i += 7;
        j += 17;
        minecraft.getTextureManager().bindTexture(EMPTY_TILE);
        for(int x = 0; x < 9; x++)
        {
            for(int y = 0; y < inventoryRows; y++)
            {
                if(inv.shouldRenderOverlay(x, y))
                {
                    blit(i + 18 * x, j + 18 * y, 0, 0, 18, 18);
                }
            }
        }
    }
}
