package me.km.networking;

import com.mojang.blaze3d.platform.GlStateManager;
import me.km.KajetansMod;
import me.km.utils.ClientReflectionUtils;
import net.minecraft.client.Minecraft;
import net.minecraft.client.gui.AbstractGui;
import net.minecraft.client.gui.FontRenderer;
import net.minecraft.util.ResourceLocation;
import net.minecraftforge.api.distmarker.Dist;
import net.minecraftforge.api.distmarker.OnlyIn;

@OnlyIn(Dist.CLIENT)
public class ItemStackDisplayGui extends AbstractGui
{
    private static final ResourceLocation CUSTOM_ICONS = new ResourceLocation(KajetansMod.MODID, "textures/gui/itemstacks.png");
    
    public final static ItemStackDisplayGui INSTANCE = new ItemStackDisplayGui(Minecraft.getInstance());
    
    private final Minecraft mc;
    private final int[] icons = new int[27];
    private boolean inactive = true;
    
    public ItemStackDisplayGui(Minecraft mc)
    {
        this.mc = mc;
        clear();
    }  
    
    public void setActive(boolean active)
    {
        this.inactive = !active;
    }
    
    public void setIcon(int index, int i, int count)
    {
        if(index >= 0 && index < 9)
        {
            index *= 3;
            icons[index] = i < 8 ? 192 + ((i % 4) << 4) : (((i - 8) & 0xF) << 4);
            icons[index + 1] = i < 8 ? (i / 4) << 4 : 32 + (((i - 8) >> 4) << 4);
            icons[index + 2] = count;
        }
    }
    
    public final void clear()
    {
        for(int i = 0; i < 27; i += 3)
        {
            icons[i] = -1;
            icons[i + 1] = 0;
            icons[i + 2] = 0;
        }
    }
    
    public void paint()
    {
        if(inactive)
        {
            return;
        }
        
        GlStateManager.enableBlend();
        GlStateManager.color4f(1.0F, 1.0F, 1.0F, 1.0F);
        
        mc.getTextureManager().bindTexture(CUSTOM_ICONS);
        
        int screenWidth = (mc.mainWindow.getScaledWidth() >> 1) - 91;
        int y = 3;
        
        if(ClientReflectionUtils.isRenderingBossBar())
        {
            y += 20;
        }
        
        blit(screenWidth, y - 3, 0, 0, 182, 22);
        
        int i = 0;
        for(int x = 3; x < 164; x += 20)
        {
            if(icons[i] != -1)
            {
                blit(screenWidth + x, y, icons[i], icons[i + 1], 16, 16);
            }
            i += 3;
        }
        
        GlStateManager.disableBlend();
        
        FontRenderer fr = mc.fontRenderer;
        String s;
        i = 2;
        for(int x = 20; x < 181; x += 20)
        {
            if(icons[i] != 0)
            {
                s = String.valueOf(icons[i]);
                fr.drawStringWithShadow(s, (float)(screenWidth + x - fr.getStringWidth(s)), y + 9, 16777215);
            }             
            i += 3;
        }
    }
}
