package me.km.world;

import me.hammerle.snuviscript.code.ISnuviLogger;
import me.km.utils.ReflectionUtils;
import net.minecraft.server.MinecraftServer;
import net.minecraft.world.World;
import net.minecraft.world.dimension.DimensionType;
import net.minecraft.world.server.ServerWorld;
import net.minecraft.world.storage.WorldInfo;
import net.minecraftforge.common.DimensionManager;
import net.minecraftforge.event.world.WorldEvent;
import net.minecraftforge.eventbus.api.SubscribeEvent;

public class WorldEvents
{
    private final ISnuviLogger logger;
    
    public WorldEvents(ISnuviLogger logger)
    {
        this.logger = logger;
    }
    
    @SubscribeEvent
    public void onWorldLoad(WorldEvent.Load e)
    {      
        World w = e.getWorld().getWorld();
        
        org.apache.logging.log4j.LogManager.getLogger().warn("Try swapping " + w + " " + w.getDimension().getType());
        
        if(w.getDimension().getType().isVanilla())
        {
            org.apache.logging.log4j.LogManager.getLogger().warn("no swap in vanilla world");
            return;
        }
        
        ServerWorld overworld = DimensionManager.getWorld(w.getServer(), DimensionType.OVERWORLD, false, false);
        if(overworld == null)
        {
            org.apache.logging.log4j.LogManager.getLogger().warn("cannot get overworld");
            return;
        }
        
        DimensionManager.keepLoaded(w.getDimension().getType(), true);
        ReflectionUtils.setWorldInfo(w, new ModWorldInfo(overworld.getWorldInfo(), WorldManager.getName(w), logger, w.getServer()));
    }
    
    @SubscribeEvent
    public void onWorldUnload(WorldEvent.Unload e)
    {      
        WorldInfo info = e.getWorld().getWorld().getWorldInfo();
        if(info instanceof ModWorldInfo)
        {
            ((ModWorldInfo) info).onSave();
        }
    } 
}
